;__________________________________________________________________________________________________
;|-------------------------------------------------------------------------------------------------|
;| : -   /                      |
;|                    .  ( 10-2001)        |
;|                     RB0 ( 6)        |
;|-------------------------------------------------------------------------------------------------|
;| :      picmaniac (picmaniac@rambler.ru)  : 1.1_S  : 05  2004 .  FREEWARE |
;|-------------------------------------------------------------------------------------------------|
;|-------------------------------------------------------------------------------------------------|
;|  :       .  5       |
;|                       (Melody0).   (Melody1-11)|
;|                       10  (    CYCLES   |
;|                       ).  Melody11     Melody0.   |
;|                       " ".                     |
;|                                               |
;|                         .              |
;|                          ,         |
;|                       .                                                |
;|-------------------------------------------------------------------------------------------------|
;|    :  PIC16F628,  0,1    .|
;|                                8      PORTB ( 6-13)   |
;|                                ,   "".                                       |
;|                                 (R>50   )  RA2, RA3   ( 1,2).   |
;|                                 ( )   RA0 ( 17)  ""|
;|                                ""  (15 )  ""  RA0, _MCLR.  |
;|                                  INTRC (4 ),    .|
;|                                 : 680  - 307 ()                  |
;|                                  ()    510  - 307 ()                  |
;|                                                     1   -                    |
;|                                                     560  -                     |
;|                                                     510  -                    |
;|                                                     10  -   (-)      |
;|-------------------------------------------------------------------------------------------------|
;|   :    MPLAB 5.70.40  WINDOWS 98SE                         |
;|                                 :   |
;|                         play B'HHHHHDDD' HHHHH -  , DDD -  .              |
;|                          - .   .                                    |
;|-------------------------------------------------------------------------------------------------|
;|          .       |
;|_________________________________________________________________________________________________|

                    LIST P=16F628   
                    #include <P16F628.inc>          ;    MPLAB
                    __CONFIG 03F30h                 ;WDT=off, BODEN=off, LVP = off, OSC = INTRC 4MHz
		    radix     hex

	#define     BUTTON PORTA,0 ;   RA0

;                          ---   ---

SONGS   EQU     D'12'              ;    
CYCLES  EQU     D'10'              ;      

DELAY1  EQU     D'110'             ;   / (-)
DELAY2  EQU     D'104'             ;   
DELAY3  EQU     D'65'              ;    
DELAY4  EQU     D'65'              ;       4-2-4
DELAY5  EQU     D'240'             ;   ""

;                         ---  ---

jnz	MACRO	Metka1             ;  ,
	btfss	STATUS,Z           ;     
	goto	Metka1
	endm
jz	MACRO	Metka2             ;  ,
	btfsc	STATUS,Z           ;    
	goto	Metka2
	endm
jnc	MACRO	Metka3             ;  ,
	btfss	STATUS,C	   ;   
	goto	Metka3
	endm
jc	MACRO	Metka4             ;  ,
	btfsc	STATUS,C	   ;  
	goto	Metka4
	endm
mov     MACRO   DEST1,SOURCE1      ;  -
	movf    SOURCE1,W
	movwf   DEST1
	endm
mvi     MACRO   DEST2,CONST2       ;    
	movlw   CONST2
	movwf   DEST2
	endm
play    MACRO   NOTA               ;  1     
	movlw   NOTA
	call    Sound
	endm
;                         ---   ---
W_copy           EQU      070h              ;    
ST_copy          EQU      071h              ; 
ADDRESS          EQU      072h              ;  ,   

SPEED            EQU      073h              ; 
DURATION         EQU      074h              ; 
TONE             EQU      075h              ; 
NUMBER           EQU      076h              ; 

COUNTER          EQU      077h              ;    
LONGTIMER        EQU      078h              ;  
OUT              EQU      079h              ; 

TEMP1            EQU      07Ah              ;  
TEMP2            EQU      07Bh              ;  
TEMP3            EQU      07Ch
TEMP4            EQU      07Dh

TIME             EQU      07Eh              ;   
CHANGE           EQU      07Fh              ;/

BYTE00           EQU      020h              ;    
BYTE01           EQU      021h
BYTE02           EQU      022h
BYTE03           EQU      023h
BYTE04           EQU      024h
BYTE05           EQU      025h
BYTE06           EQU      026h
BYTE07           EQU      027h
BYTE08           EQU      028h
BYTE09           EQU      029h
BYTE0A           EQU      02Ah
BYTE0B           EQU      02Bh
BYTE0C           EQU      02Ch
BYTE0D           EQU      02Dh
BYTE0E           EQU      02Eh
BYTE0F           EQU      02Fh
BYTE10           EQU      030h
BYTE11           EQU      031h
BYTE12           EQU      032h
BYTE13           EQU      033h
BYTE14           EQU      034h
BYTE15           EQU      035h
BYTE16           EQU      036h
BYTE17           EQU      037h
BYTE18           EQU      038h
BYTE19           EQU      039h
BYTE1A           EQU      03Ah
BYTE1B           EQU      03Bh
BYTE1C           EQU      03Ch
BYTE1D           EQU      03Dh
BYTE1E           EQU      03Eh
BYTE1F           EQU      03Fh

;                              ---  ---
                 ORG 0                      ; 
Reset            bcf       STATUS,RP0       ;   0
		 movlw     B'00000111'      ;    
		 movwf     CMCON            ;    
                 goto      Begin            ;    
;--------------------------------------------------------------------------------------------------
;                       ---   ---
;--------------------------------------------------------------------------------------------------
                 ORG 4                           ; 
Interrupt        movwf     W_copy                ; 
                 mov       ST_copy,STATUS

                 movlw     B'10000000'           ; TMR0,
                 movwf     TMR0                  ;   

                 movf      ADDRESS,W             ;       
                 movwf     FSR                   ;  FSR ( )
                 comf      INDF,W                ;        W
						 ; , ..    ""
                 movwf     PORTB                 ;     PORTB

                 movlw     BYTE1F                ;   BYTE1F  W
                 xorwf     ADDRESS,W             ;  ,     BYTE00
                 btfss     STATUS,Z              ; , Z=1,  
                 goto      Int_label             ;  , 
                 movlw     BYTE00                ;    Byte0
                 movwf     ADDRESS               ;  ADDRESS -   
                 goto      Button_label

Int_label        incf      ADDRESS,F             ;      

		 movf      LONGTIMER,W           ;   ?
		 jz        PlaybackN             ; -     

Button_label     btfsc     BUTTON
		 goto      End_int               ;    - 

		 call      Led_all_100           ;  (   )

		 btfsc     BUTTON
		 goto      End_int               ;    - 

Wait_label	 btfss     BUTTON
		 goto      Wait_label            ;  
		 call      Led_all_100           ;  (   )

PlaybackN 	 clrf      COUNTER               ;   

		 movf      NUMBER,W
		 sublw     D'11'                 ; -  NUMBER   11
		 btfss     STATUS,C              ;   
		 goto      Finish                ;   Finish
		 sublw     D'11'                 ;  

		 clrf      PCLATH
		 addwf     PCL,F                 ;      NUMBER
		 goto      Melody0
		 goto      Melody1
		 goto      Melody2
		 goto      Melody3
		 goto      Melody4
		 goto      Melody5
		 goto      Melody6
		 goto      Melody7
		 goto      Melody8
		 goto      Melody9
		 goto      Melody10
		 goto      Melody11

Finish		 movf      LONGTIMER,W           ;     ?
		 jnz       Demand_label          ; - 

		 incf      NUMBER,F              ;    
		 movf      NUMBER,W
		 sublw     SONGS-1               ;(SONGS-1-W) --> W
		 btfss     STATUS,C              ;     ?
		 clrf      NUMBER                ; -    
		 mvi       LONGTIMER,CYCLES      ;  -     

Demand_label	 call      Led_all_100
		 movlw     D'200'
		 call      Pause

Wait2_label	 btfss     BUTTON
		 goto      Wait2_label           ;  

End_int          bcf       INTCON,T0IF           ;      
		 mov       STATUS,ST_copy        ; 
                 swapf     W_copy,F              ;  ,    Z  STATUS
                 swapf     W_copy,W              ;(MOVF   ,  SWAPF - )
                 retfie                          ;      GIE
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
;                          ---  ---
;--------------------------------------------------------------------------------------------------
                ;  
;--------------------------------------------------------------------------------------------------
		;  

Dec_dur		 clrf      PCLATH
		 addwf     PCL,F
		 retlw     D'8'             ;"HHHHH000" = 1/8
		 retlw     D'16'            ;"HHHHH001" = 1/4
		 retlw     D'32'            ;"HHHHH010" = 1/2
		 retlw     D'48'            ;"HHHHH011" = 3/4
		 retlw     D'64'            ;"HHHHH100" = 1
		 retlw     D'96'            ;"HHHHH101" = 3/2
		 retlw     D'128'           ;"HHHHH110" = 2
		 retlw     D'255'           ;"HHHHH111" = 4

		;  

Dc_tone		 sublw     D'24'            ; -     24
		 btfss     STATUS,C         ;   
		 retlw     00h              ;  0 ()
		 clrf      PCLATH
		 sublw     D'24'            ;  
		 addwf     PCL,F
		 retlw     D'252'           ;"00000DDD" = "" 1-  (494 )
		 retlw     D'238'           ;"00001DDD" = "" 2-  (524 )
		 retlw     D'224'           ;  ...
		 retlw     D'212'
		 retlw     D'202'
		 retlw     D'190'
		 retlw     D'178'
		 retlw     D'168'
		 retlw     D'158'
		 retlw     D'150'
		 retlw     D'142'
		 retlw     D'134'
		 retlw     D'126'           ;"" 2-  (988 )
		 retlw     D'119'           ;"" 3-  (1048 )
		 retlw     D'112'
		 retlw     D'106'
		 retlw     D'101'
		 retlw     D'95'
		 retlw     D'89'
		 retlw     D'84'
		 retlw     D'79'
		 retlw     D'75'
		 retlw     D'71'
		 retlw     D'67'
		 retlw     D'63'           ;"" 3-  (1976 )

		;        

Dcd8		 andlw     B'00000111'      ;   3  (.. 8 )
		 clrf      PCLATH
		 addwf     PCL,F
		 retlw     B'11111110'
		 retlw     B'11111101'
		 retlw     B'11111011'
		 retlw     B'11110111'
		 retlw     B'11101111'
		 retlw     B'11011111'
		 retlw     B'10111111'
		 retlw     B'01111111'
;--------------------------------------------------------------------------------------------------
                ; 
;--------------------------------------------------------------------------------------------------
                ;  (  TEMP1)

Pause            movwf     TEMP1            ;     W (  )
		 movf      TEMP1,F          ;  0
		 btfsc     STATUS,Z         ;    0,  Z=0   return
		 return                     ;    0,   
		 clrw                       ; W
P_label          addlw     01h              ;   W
                 btfss     STATUS,Z         ;
                 goto      P_label          ;
                 decfsz    TEMP1,F          ;   TEMP1
                 goto      P_label          ;   
		 return                     ;  

		;      100 

Led_all_100	 clrf      PORTB
		 movlw     D'100'
		 call      Pause
		 mvi       PORTB,0FFh
		 return
;--------------------------------------------------------------------------------------------------
                ; 
;--------------------------------------------------------------------------------------------------
                ;   

Sound		 btfss     BUTTON
		 return                     ;   -  return

		 movwf     TONE             ;    (   W)
		 andlw     B'00000111'      ;
		 call      Dec_dur          ;   
		 movwf     DURATION         ;  - ,   

		 rrf       TONE,F
		 rrf       TONE,F
		 rrf       TONE,W           ;...
		 andlw     B'00011111'      ;
		 call      Dc_tone          ;   
		 movwf     TONE             ;  - ,   

		 movf      COUNTER,W
		 call      Dcd8             ; ,   W
                 movwf     PORTB            ;     PORTB
		 incf      COUNTER,F        ;   

		 bsf       STATUS,RP0       ;   1    OPTION_REG
		 mvi       OPTION_REG,05h   ;    TMR0
		 bcf       STATUS,RP0       ;   0

		 movf      TONE,F
		 btfss     STATUS,Z         ; TONE=0,  
		 bsf       OUT,2            ;   RA2  RA3
		 
Loop_label	 mov       TMR0,SPEED       ;  SPEED -   
		 bcf       INTCON,T0IF      ;      - 

Pulse_label	 movf      OUT,W
		 movf      TONE,F
		 btfss     STATUS,Z         ; TONE=0,  
		 movwf     PORTA            ;  OUT --> W --> PORTA

		 movf      TONE,W
		 addlw     D'253'           ;: (W-3) --> W
S_label1	 addlw     0FFh             ;(W-1) --> W
		 btfss     STATUS,Z
		 goto      S_label1

		 bcf       OUT,2
		 bsf       OUT,3            ;   

		 movf      OUT,W
		 movf      TONE,F
		 btfss     STATUS,Z         ; TONE=0,  
		 movwf     PORTA            ;  OUT --> W --> PORTA

		 decf      TONE,W           ;
S_label2	 addlw     0FFh             ;(W-1) --> W
		 btfss     STATUS,Z
		 goto      S_label2

		 bcf       OUT,3
		 bsf       OUT,2            ; 

		 btfss     INTCON,T0IF
		 goto      Pulse_label


Breakpoint1	 decfsz    DURATION,F       ;
		 goto      Loop_label

		 bcf       OUT,2            ;   
		 mov       PORTA,OUT        ;    TONE  

		 movlw     D'4'             ;  
		 call      Pause

		 bsf       STATUS,RP0       ;   1    OPTION_REG
		 mvi       OPTION_REG,0     ;   
		 bcf       STATUS,RP0       ;   0

					    ;      
		 btfsc     BUTTON
		 goto      End_snd          ;    - 
		 movlw     D'100'
		 call      Pause
		 btfsc     BUTTON
		 goto      End_snd          ;    - 

		 incf      NUMBER,F         ;    
		 movf      NUMBER,W
		 sublw     SONGS-1          ;(SONGS-1-W) --> W
		 btfss     STATUS,C         ;     ?
		 clrf      NUMBER           ; -    

End_snd		 return
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
                ;    
;--------------------------------------------------------------------------------------------------
                ;        32    
						 ;   
Decode5_32       movf      BYTE01,W              ;     
                 movwf     BYTE02                ;(    )

                 movf      BYTE03,W              ; -  
                 movwf     BYTE04
                 movwf     BYTE05
                 movwf     BYTE06
                 
                 movf      BYTE07,W              ; -  
                 movwf     BYTE08
                 movwf     BYTE09
                 movwf     BYTE0A
                 movwf     BYTE0B
                 movwf     BYTE0C
                 movwf     BYTE0D
                 movwf     BYTE0E

                 movf      BYTE0F,W              ;  -   
                 movwf     BYTE10
                 movwf     BYTE11
                 movwf     BYTE12                ; 1+2+4+8+16 = 31   32 
                 movwf     BYTE13
                 movwf     BYTE14
                 movwf     BYTE15
                 movwf     BYTE16
                 movwf     BYTE17
                 movwf     BYTE18
                 movwf     BYTE19
                 movwf     BYTE1A
                 movwf     BYTE1B
                 movwf     BYTE1C
                 movwf     BYTE1D
                 movwf     BYTE1E

                 clrf      BYTE1F                ;Let it be
                 return                          ;  
;--------------------------------------------------------------------------------------------------
                ;     

Roll		 bcf       INTCON,GIE            ;  (   )
		 movf      TEMP3,W               ;  
		 jz        Bypassroll_lbl        ; 0,    

Roll_label	 bcf       STATUS,C              ;  
		 rlf       BYTE00,F              ;   1
		 btfsc     STATUS,C              ;     = 1 ?
		 bsf       BYTE00,0              ; -   
		 bcf       STATUS,C
		 rlf       BYTE01,F
		 btfsc     STATUS,C
		 bsf       BYTE01,0
		 bcf       STATUS,C
		 rlf       BYTE03,F
		 btfsc     STATUS,C
		 bsf       BYTE03,0
		 bcf       STATUS,C
		 rlf       BYTE07,F
		 btfsc     STATUS,C
		 bsf       BYTE07,0
		 bcf       STATUS,C
		 rlf       BYTE0F,F
		 btfsc     STATUS,C
		 bsf       BYTE0F,0
		 addlw     D'255'                ; W
		 jnz       Roll_label

Bypassroll_lbl	 call      Decode5_32            ;
		 bsf       INTCON,GIE            ; 
                 movf      TIME,W
		 call      Pause
		 return
;--------------------------------------------------------------------------------------------------
		;    (   )

Send             bcf       INTCON,GIE            ; 
		 call      Decode5_32            ;
		 bsf       INTCON,GIE            ; 
                 movf      TIME,W
		 call      Pause
		 return
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
                ;     

Burn_on          clrf      BYTE00                 ;    
                 clrf      BYTE01                 ;0-1-2-3-4-5-6-8-10-12-16-24-31--0-1-...
                 clrf      BYTE03
                 clrf      BYTE07
                 clrf      BYTE0F
		 call      Send                   ;0
                 comf      BYTE00,F               ;on
		 call      Send                   ;1
                 comf      BYTE00,F               ;off
                 comf      BYTE01,F               ;on
		 call      Send                   ;2
                 comf      BYTE00,F               ;on
		 call      Send                   ;3
                 comf      BYTE00,F               ;off
                 comf      BYTE01,F               ;off
                 comf      BYTE03,F               ;on
		 call      Send                   ;4
                 comf      BYTE00,F               ;on
		 call      Send                   ;5
                 comf      BYTE00,F               ;off
                 comf      BYTE01,F               ;on
		 call      Send                   ;6
                 comf      BYTE01,F               ;off
                 comf      BYTE03,F               ;off
                 comf      BYTE07,F               ;on
		 call      Send                   ;8
                 comf      BYTE01,F               ;on
		 call      Send                   ;10
                 comf      BYTE01,F               ;off
                 comf      BYTE03,F               ;on
		 call      Send                   ;12
                 comf      BYTE03,F               ;off
                 comf      BYTE07,F               ;off
                 comf      BYTE0F,F               ;on
		 call      Send                   ;16
                 comf      BYTE07,F               ;on
		 call      Send                   ;24
                 comf      BYTE00,F               ;on
                 comf      BYTE01,F               ;on
                 comf      BYTE03,F               ;on
		 call      Send                   ;31
                 return                          ;  
;--------------------------------------------------------------------------------------------------
                ;     

Burn_off         movlw     0FFh                  ;    
                 movwf     BYTE00
                 movwf     BYTE01
                 movwf     BYTE03
                 movwf     BYTE07
                 movwf     BYTE0F
		 call      Send                   ;31
                 comf      BYTE00,F               ;off
                 comf      BYTE01,F               ;off
                 comf      BYTE03,F               ;off
		 call      Send                   ;24
                 comf      BYTE07,F               ;off
		 call      Send                   ;16
                 comf      BYTE0F,F               ;off
                 comf      BYTE03,F               ;on
                 comf      BYTE07,F               ;on
		 call      Send                   ;12
                 comf      BYTE03,F               ;off
                 comf      BYTE01,F               ;on
		 call      Send                   ;10
                 comf      BYTE01,F               ;off
		 call      Send                   ;8
                 comf      BYTE07,F               ;off
                 comf      BYTE01,F               ;on
                 comf      BYTE03,F               ;on
		 call      Send                   ;6
                 comf      BYTE01,F               ;off
                 comf      BYTE00,F               ;on
		 call      Send                   ;5
                 comf      BYTE00,F               ;off
		 call      Send                   ;4
                 comf      BYTE03,F               ;off
                 comf      BYTE01,F               ;on
                 comf      BYTE00,F               ;on
		 call      Send                   ;3
                 comf      BYTE00,F               ;off
		 call      Send                   ;2
                 comf      BYTE01,F               ;off
                 comf      BYTE00,F               ;on
		 call      Send                   ;1
                 comf      BYTE00,F               ;off
		 call      Send                   ;0
                 return                           ;  
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
                ;   

SPIN00           clrf      BYTE00
                 mvi       BYTE01,B'00000011'
                 movwf     BYTE03
                 clrf      BYTE07
                 clrf      BYTE0F
		 call      Roll
                 return
SPIN01           mvi       BYTE00,B'00000001'
                 movwf     BYTE03
                 clrf      BYTE01
                 mvi       BYTE07,B'00000010'
                 clrf      BYTE0F
		 call      Roll
                 return
SPIN02           clrf      BYTE00
                 mvi       BYTE01,B'00000010'
                 movwf     BYTE07
                 mvi       BYTE03,B'00000001'
                 clrf      BYTE0F
		 call      Roll
                 return
SPIN03           mvi       BYTE00,B'00000001'
                 movwf     BYTE01
                 mvi       BYTE03,B'00000010'
                 movwf     BYTE07
                 clrf      BYTE0F
		 call      Roll
                 return
SPIN04           clrf      BYTE00
                 mvi       BYTE01,B'00000001'
                 clrf      BYTE03
                 clrf      BYTE07
                 mvi       BYTE0F,B'00000010'
		 call      Roll
                 return
SPIN05           mvi       BYTE00,B'00000001'
                 clrf      BYTE01
                 clrf      BYTE03
                 mvi       BYTE07,B'00000010'
                 movwf     BYTE0F
		 call      Roll
                 return
SPIN06           mvi       BYTE00,B'00000010'
                 movwf     BYTE01
                 movwf     BYTE03
                 movwf     BYTE07
                 movwf     BYTE0F
		 call      Roll
                 return
SPIN07           mvi       BYTE00,B'00000100'
                 clrf      BYTE01
                 clrf      BYTE03
                 mvi       BYTE07,B'00000010'
                 movwf     BYTE0F
		 call      Roll
                 return
SPIN08           clrf      BYTE00
                 mvi       BYTE01,B'00000100'
                 clrf      BYTE03
                 clrf      BYTE07
                 mvi       BYTE0F,B'00000010'
		 call      Roll
                 return
SPIN09           mvi       BYTE00,B'00000100'
                 movwf     BYTE01
                 mvi       BYTE03,B'00000010'
                 movwf     BYTE07
                 clrf      BYTE0F
		 call      Roll
                 return
SPIN10           clrf      BYTE00
                 mvi       BYTE01,B'00000010'
                 movwf     BYTE07
                 mvi       BYTE03,B'00000100'
                 clrf      BYTE0F
		 call      Roll
                 return
SPIN11           mvi       BYTE00,B'00000100'
                 movwf     BYTE03
                 clrf      BYTE01
                 mvi       BYTE07,B'00000010'
                 clrf      BYTE0F
		 call      Roll
                 return
;--------------------------------------------------------------------------------------------------
                ;    

SPIN_LCYCLE      call      SPIN00
		 call      SPIN01
		 call      SPIN02
		 call      SPIN03
		 call      SPIN04
		 call      SPIN05
		 call      SPIN06
		 call      SPIN07
		 call      SPIN08
		 call      SPIN09
		 call      SPIN10
		 call      SPIN11
		 return
;--------------------------------------------------------------------------------------------------
                ;    

SPIN_RCYCLE      call      SPIN11
		 call      SPIN10
		 call      SPIN09
		 call      SPIN08
		 call      SPIN07
		 call      SPIN06
		 call      SPIN05
		 call      SPIN04
		 call      SPIN03
		 call      SPIN02
		 call      SPIN01
		 call      SPIN00
		 return
;--------------------------------------------------------------------------------------------------
                ;      /

LEFTSPIN	 clrf      TEMP3                 ;  

Spin1label	 call      SPIN_LCYCLE
                 movf      CHANGE,W              ;    
		 addwf     TIME,F

		 incf      TEMP3,F               ;  -  

		 movlw     08h
		 xorwf     TEMP3,W               ;  ?
		 jnz       Spin1label            ; -  

                 decfsz    TEMP2,F               ;  ?
                 goto      LEFTSPIN              ; -  

		 return
;--------------------------------------------------------------------------------------------------
                ;      /

RIGHTSPIN	 mvi       TEMP3,07h             ;   

Spin2label	 call      SPIN_RCYCLE
                 movf      CHANGE,W              ;    
		 addwf     TIME,F

		 decf      TEMP3,F               ;  -  

		 movlw     D'255'
		 xorwf     TEMP3,W               ;  ?
		 jnz       Spin2label            ; -  

                 decfsz    TEMP2,F               ;  ?
                 goto      RIGHTSPIN             ; -  

		 return
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
                ;     -

EVENODD1         clrf      BYTE00
                 clrf      BYTE01
                 mvi       BYTE03,B'11111111'
                 clrf      BYTE07
                 clrf      BYTE0F
		 call      Send
                 return

EVENODD2         mvi       BYTE00,B'01010101'
                 movwf     BYTE01
                 clrf      BYTE03
                 mvi       BYTE07,B'10101010'
                 clrf      BYTE0F
		 call      Send
                 return

EVENODD3         clrf      BYTE00
                 mvi       BYTE01,B'01010101'
                 clrf      BYTE03
                 clrf      BYTE07
                 mvi       BYTE0F,B'10101010'
		 call      Send
                 return

EVENODD4         mvi       BYTE00,B'01010101'
                 clrf      BYTE01
                 clrf      BYTE03
                 mvi       BYTE07,B'10101010'
                 movwf     BYTE0F
		 call      Send
                 return

EVENODD5         mvi       BYTE00,B'10101010'
                 movwf     BYTE01
                 movwf     BYTE03
                 movwf     BYTE07
                 movwf     BYTE0F
		 call      Send
                 return

EVENODD6         mvi       BYTE00,B'10101010'
                 movwf     BYTE01
                 clrf      BYTE03
                 mvi       BYTE07,B'01010101'
                 clrf      BYTE0F
		 call      Send
                 return

EVENODD7         clrf      BYTE00
                 mvi       BYTE01,B'10101010'
                 clrf      BYTE03
                 clrf      BYTE07
                 mvi       BYTE0F,B'01010101'
		 call      Send
                 return

EVENODD8         mvi       BYTE00,B'10101010'
                 clrf      BYTE01
                 clrf      BYTE03
                 mvi       BYTE07,B'01010101'
                 movwf     BYTE0F
		 call      Send
                 return

EVENODD9         mvi       BYTE00,B'01010101'
                 movwf     BYTE01
                 movwf     BYTE03
                 movwf     BYTE07
                 movwf     BYTE0F
		 call      Send
                 return
;--------------------------------------------------------------------------------------------------
                ;     

EVEN_ODD         call      EVENODD1              ;     
                 call      EVENODD2
                 call      EVENODD3
                 call      EVENODD4
                 call      EVENODD5
                 call      EVENODD4
                 call      EVENODD3
                 call      EVENODD2
                 call      EVENODD1
                 movf      CHANGE,W              ;    
		 addwf     TIME,F
                 call      EVENODD6
                 call      EVENODD7
                 call      EVENODD8
                 call      EVENODD9
                 call      EVENODD8
                 call      EVENODD7
                 call      EVENODD6
                 movf      CHANGE,W              ;    
		 addwf     TIME,F

                 decfsz    TEMP2,F               ;    TEMP2  1
                 goto      EVEN_ODD              ;      - 
		 return
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
                ;    ()  

ZERO             clrf      BYTE00
		 clrf      BYTE01
		 clrf      BYTE03
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
ONE1             mvi       BYTE00,B'00000001'
		 clrf      BYTE01
		 clrf      BYTE03
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
ONE2             clrf      BYTE00
                 mvi       BYTE01,B'00000001'
		 clrf      BYTE03
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
ONE3             mvi       BYTE00,B'00000001'
                 movwf     BYTE01
		 clrf      BYTE03
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
ONE4             clrf      BYTE00
                 clrf      BYTE01
                 mvi       BYTE03,B'00000001'
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
ONE6             clrf      BYTE00
                 mvi       BYTE01,B'00000001'
                 movwf     BYTE03
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
ONE8             clrf      BYTE00
                 clrf      BYTE01
                 clrf      BYTE03
                 mvi       BYTE07,B'00000001'
                 clrf      BYTE0F
		 call      Roll
                 return
ONE10            clrf      BYTE00
                 mvi       BYTE01,B'00000001'
                 movwf     BYTE07
                 clrf      BYTE03
                 clrf      BYTE0F
		 call      Roll
                 return
ONE12            clrf      BYTE00
                 clrf      BYTE01
                 mvi       BYTE03,B'00000001'
                 movwf     BYTE07
                 clrf      BYTE0F
		 call      Roll
                 return
ONE16            clrf      BYTE00
		 clrf      BYTE01
		 clrf      BYTE03
		 clrf      BYTE07
                 mvi       BYTE0F,B'00000001'
		 call      Roll
                 return
ONE24            clrf      BYTE00
		 clrf      BYTE01
		 clrf      BYTE03
                 mvi       BYTE07,B'00000001'
                 movwf     BYTE0F
		 call      Roll
                 return
ONE31            mvi       BYTE00,B'00000001'
                 movwf     BYTE01
                 movwf     BYTE03
                 movwf     BYTE07
                 movwf     BYTE0F
		 call      Roll
                 return
;--------------------------------------------------------------------------------------------------
                ;a       

ONE_CYCLE 	 call      ZERO
		 call      ONE1
		 call      ONE2
		 call      ONE3
		 call      ONE4
		 call      ONE6
		 call      ONE8
		 call      ONE10
		 call      ONE12
		 call      ONE16
		 call      ONE24
		 call      ONE31
		 call      ONE24
		 call      ONE16
		 call      ONE12
		 call      ONE10
		 call      ONE8
		 call      ONE6
		 call      ONE4
		 call      ONE3
		 call      ONE2
		 call      ONE1
		 call      ZERO
		 return
;--------------------------------------------------------------------------------------------------
                ; "  " 

LEFT_ONE	 clrf      TEMP3                 ;  

Left1label	 call      ONE_CYCLE
                 movf      CHANGE,W              ;    
		 addwf     TIME,F

		 incf      TEMP3,F               ;  -  

		 movlw     D'8'
		 xorwf     TEMP3,W               ;  ?
		 jnz       Left1label            ; -  

                 decfsz    TEMP2,F               ;  ?
                 goto      LEFT_ONE              ; -  

		 return
;--------------------------------------------------------------------------------------------------
                ; "  " 

RIGHT_ONE	 mvi       TEMP3,07h             ;   

Right1label	 call      ONE_CYCLE
                 movf      CHANGE,W              ;    
		 addwf     TIME,F

		 decf      TEMP3,F               ;  -  

		 movlw     D'255'
		 xorwf     TEMP3,W               ;  ?
		 jnz       Right1label           ; -  

                 decfsz    TEMP2,F               ;  ?
                 goto      RIGHT_ONE             ; -  

		 return
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
                ;       

TWOFOUR01        mvi       BYTE00,B'01010101'
		 clrf      BYTE01
		 clrf      BYTE03
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWOFOUR02        clrf      BYTE00
                 mvi       BYTE01,B'01010101'
		 clrf      BYTE03
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWOFOUR03        mvi       BYTE00,B'01010101'
                 movwf     BYTE01
		 clrf      BYTE03
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWOFOUR04        clrf      BYTE00
		 clrf      BYTE01
                 mvi       BYTE03,B'01010101'
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWOFOUR06    	 clrf      BYTE00
                 mvi       BYTE01,B'01010101'
                 movwf     BYTE03
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWOFOUR07        mvi       BYTE00,B'01000100'
                 movwf     BYTE03
		 clrf      BYTE01
                 mvi       BYTE07,B'00010001'
		 clrf      BYTE0F
		 call      Roll
                 return
TWOFOUR08        clrf      BYTE00
                 mvi       BYTE01,B'00010001'
                 movwf     BYTE07
                 mvi       BYTE03,B'01000100'
		 clrf      BYTE0F
		 call      Roll
                 return
TWOFOUR09        mvi       BYTE00,B'01000100'
                 movwf     BYTE01
                 mvi       BYTE03,B'00010001'
                 movwf     BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWOFOUR10        clrf      BYTE00
                 mvi       BYTE01,B'01000100'
		 clrf      BYTE03
		 clrf      BYTE07
                 mvi       BYTE0F,B'00010001'
		 call      Roll
                 return
TWOFOUR11        mvi       BYTE00,B'01000100'
		 clrf      BYTE01
		 clrf      BYTE03
                 mvi       BYTE07,B'00010001'
                 movwf     BYTE0F
		 call      Roll
                 return
TWOFOUR12        mvi       BYTE00,B'00010001'
                 movwf     BYTE01
                 movwf     BYTE03
                 movwf     BYTE07
                 movwf     BYTE0F
		 call      Roll
                 return
TWOFOUR13        mvi       BYTE00,B'00010001'
                 movwf     BYTE03
		 clrf      BYTE01
                 mvi       BYTE07,B'01000100'
		 clrf      BYTE0F
		 call      Roll
                 return
TWOFOUR14        clrf      BYTE00
                 mvi       BYTE01,B'01000100'
                 movwf     BYTE07
                 mvi       BYTE03,B'00010001'
		 clrf      BYTE0F
		 call      Roll
                 return
TWOFOUR15        mvi       BYTE00,B'00010001'
                 movwf     BYTE01
                 mvi       BYTE03,B'01000100'
                 movwf     BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWOFOUR16        clrf      BYTE00
                 mvi       BYTE01,B'00010001'
		 clrf      BYTE03
		 clrf      BYTE07
                 mvi       BYTE0F,B'01000100'
		 call      Roll
                 return
TWOFOUR17        mvi       BYTE00,B'00010001'
		 clrf      BYTE01
		 clrf      BYTE03
                 mvi       BYTE07,B'01000100'
                 movwf     BYTE0F
		 call      Roll
                 return
TWOFOUR18        mvi       BYTE00,B'01000100'
                 movwf     BYTE01
                 movwf     BYTE03
                 movwf     BYTE07
                 movwf     BYTE0F
		 call      Roll
                 return
;--------------------------------------------------------------------------------------------------
                ;       

TWOFOUR_CYCLE    call      ZERO
		 call      TWOFOUR01
		 call      TWOFOUR02
		 call      TWOFOUR03
		 call      TWOFOUR04
		 call      TWOFOUR06
		 call      TWOFOUR07
		 call      TWOFOUR08
		 call      TWOFOUR09
		 call      TWOFOUR10
		 call      TWOFOUR11
		 call      TWOFOUR12
		 call      TWOFOUR12
		 call      TWOFOUR11
		 call      TWOFOUR10
		 call      TWOFOUR09
		 call      TWOFOUR08
		 call      TWOFOUR07
		 call      TWOFOUR06
		 call      TWOFOUR13
		 call      TWOFOUR14
		 call      TWOFOUR15
		 call      TWOFOUR16
		 call      TWOFOUR17
		 call      TWOFOUR18
		 call      TWOFOUR18
		 call      TWOFOUR17
		 call      TWOFOUR16
		 call      TWOFOUR15
		 call      TWOFOUR14
		 call      TWOFOUR13
		 call      TWOFOUR06
		 call      TWOFOUR04
		 call      TWOFOUR03
		 call      TWOFOUR02
		 call      TWOFOUR01
		 call      ZERO
		 return
;--------------------------------------------------------------------------------------------------
                ;      

TWOFOUR		 clrf      TEMP3                 ;  

Twofourlabel	 call      TWOFOUR_CYCLE
                 movf      CHANGE,W              ;    
		 addwf     TIME,F

		 incf      TEMP3,F               ;  -  

		 movlw     08h
		 xorwf     TEMP3,W               ;  ?
		 jnz       Twofourlabel          ; -  

                 decfsz    TEMP2,F               ;  ?
                 goto      TWOFOUR               ; -  

		 return
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
                ;     

TWO01            mvi       BYTE00,B'00010001'
		 clrf      BYTE01
		 clrf      BYTE03
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWO02          	 clrf      BYTE00
                 mvi       BYTE01,B'00010001'
		 clrf      BYTE03
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWO03            mvi       BYTE00,B'00010001'
                 movwf     BYTE01
		 clrf      BYTE03
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWO04            clrf      BYTE00
		 clrf      BYTE01
                 mvi       BYTE03,B'00010001'
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWO05            mvi       BYTE00,B'00010001'
                 movwf     BYTE03
		 clrf      BYTE01
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWO06            clrf      BYTE00
                 mvi       BYTE01,B'00010001'
                 movwf     BYTE03
		 clrf      BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWO08            clrf      BYTE00
		 clrf      BYTE01
		 clrf      BYTE03
                 mvi       BYTE07,B'00010001'
		 clrf      BYTE0F
		 call      Roll
                 return
TWO10            clrf      BYTE00
                 mvi       BYTE01,B'00010001'
                 movwf     BYTE07
		 clrf      BYTE03
		 clrf      BYTE0F
		 call      Roll
                 return
TWO12            clrf      BYTE00
		 clrf      BYTE01
                 mvi       BYTE03,B'00010001'
                 movwf     BYTE07
		 clrf      BYTE0F
		 call      Roll
                 return
TWO16            clrf      BYTE00
		 clrf      BYTE01
		 clrf      BYTE03
		 clrf      BYTE07
                 mvi       BYTE0F,B'00010001'
		 call      Roll
                 return
TWO24            clrf      BYTE00
		 clrf      BYTE01
		 clrf      BYTE03
                 mvi       BYTE07,B'00010001'
                 movwf     BYTE0F
		 call      Roll
                 return
TWO31            mvi       BYTE00,B'00010001'
                 movwf     BYTE01
                 movwf     BYTE03
                 movwf     BYTE07
                 movwf     BYTE0F
		 call      Roll
                 return
;--------------------------------------------------------------------------------------------------
                ;     

TWO_CYCLE        call      ZERO
		 call      TWO01
		 call      TWO02
		 call      TWO03
		 call      TWO04
		 call      TWO05
		 call      TWO06
		 call      TWO08
		 call      TWO10
		 call      TWO12
		 call      TWO16
		 call      TWO24
		 call      TWO31
		 call      TWO24
		 call      TWO16
		 call      TWO12
		 call      TWO10
		 call      TWO08
		 call      TWO06
		 call      TWO05
		 call      TWO04
		 call      TWO03
		 call      TWO02
		 call      TWO01
		 call      ZERO
		 return
;--------------------------------------------------------------------------------------------------
                ;     

LEFT_TWO	 clrf      TEMP3                 ;  

Two1label	 call      TWO_CYCLE
                 movf      CHANGE,W              ;    
		 addwf     TIME,F

		 incf      TEMP3,F               ;  -  

		 movlw     08h
		 xorwf     TEMP3,W               ;  ?
		 jnz       Two1label             ; -  

                 decfsz    TEMP2,F               ;  ?
                 goto      LEFT_TWO              ; -  

		 return
;--------------------------------------------------------------------------------------------------
                ;     

RIGHT_TWO	 mvi       TEMP3,07h             ;   

Two2label	 call      TWO_CYCLE
                 movf      CHANGE,W              ;    
		 addwf     TIME,F

		 decf      TEMP3,F               ;  -  

		 movlw     D'255'
		 xorwf     TEMP3,W               ;  ?
		 jnz       Two2label             ; -  

                 decfsz    TEMP2,F               ;  ?
                 goto      RIGHT_TWO             ; -  

		 return
;--------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------
                ;a ""

SNAKE            mvi       BYTE00,B'10000101'
                 mvi       BYTE01,B'10010110'
                 mvi       BYTE03,B'10011000'
                 mvi       BYTE07,B'10100000'
                 mvi       BYTE0F,B'11000000'
		 call      Roll
                 return
;--------------------------------------------------------------------------------------------------
                ; "" 

LEFT_SNAKE	 clrf      TEMP3                 ;  

Snake1label	 call      SNAKE
                 movf      CHANGE,W              ;    
		 addwf     TIME,F

		 incf      TEMP3,F               ;  -  

		 movlw     D'8'
		 xorwf     TEMP3,W               ;  ?
		 jnz       Snake1label           ; -  

                 decfsz    TEMP2,F               ;  ?
                 goto      LEFT_SNAKE            ; -  

		 return
;--------------------------------------------------------------------------------------------------
                ; "" 

RIGHT_SNAKE	 mvi       TEMP3,07h             ;   

Snake2label	 call      SNAKE
                 movf      CHANGE,W              ;    
		 addwf     TIME,F

		 decf      TEMP3,F               ;  -  

		 movlw     D'255'
		 xorwf     TEMP3,W               ;  ?
		 jnz       Snake2label           ; -  

                 decfsz    TEMP2,F               ;  ?
                 goto      RIGHT_SNAKE           ; -  

		 return
;--------------------------------------------------------------------------------------------------
;__________________________________________________________________________________________________

;                ---    ---
;__________________________________________________________________________________________________

Begin            movf      PORTA,F          ;  
                 movf      PORTB,F          ; 
		 bcf       STATUS,RP1
		 bsf       STATUS,RP0       ;   1    TRIS  OPTION_REG
                 mvi       TRISA,B'00000001';     'OOxOOOOI'
                 mvi       TRISB,B'00000000';   B  'OOOOOOOO' (I-in, O-out)
                 mvi       OPTION_REG,0     ;  2
                 bcf       STATUS,RP0       ;   0
		 clrf      PORTA
		 mvi       PORTB,0FFh       ; 
		 clrf      OUT
		 clrf      NUMBER
                 movlw     BYTE00           ;   BYTE00
                 movwf     ADDRESS          ;  ADDRESS (  )
		 mvi       LONGTIMER,5      ;  -   5 

		 clrf      TMR0
		 mvi       INTCON,B'10100000'    ;    TMR0
;--------------------------------------------------------------------------------------------------
Mainloop_label	; 
						 ; 1 -    

		 mvi       TIME,DELAY1           ;   
                 mvi       TEMP2,05h             ;  -
Effect01         call      Burn_on               ; 
		 movf      TIME,W
                 call      Pause                 ;    
                 call      Burn_off              ;  
                 decfsz    TEMP2,F               ;    TEMP2  1
                 goto      Effect01              ;      - 

						 ; 2 - "" 

		 mvi       TIME,DELAY5           ;   
                 mvi       TEMP2,5               ;  
		 mvi       CHANGE,D'255'         ;  (  1)
		 call      LEFT_SNAKE
						 
                 mvi       TEMP2,5               ;  
		 mvi       CHANGE,D'1'           ;  (  1)
		 call      LEFT_SNAKE

						 ; 3 -    

		 mvi       TIME,DELAY3           ;   
                 mvi       TEMP2,1               ;  
		 mvi       CHANGE,D'252'         ;  (  4)
		 call      RIGHT_ONE
						 
                 mvi       TEMP2,1               ;  
		 mvi       CHANGE,D'4'           ;  (  4)
		 call      RIGHT_ONE

						 ; 4 -     

		 mvi       TIME,DELAY4           ;   
                 mvi       TEMP2,2               ; 
		 mvi       CHANGE,D'254'         ;  (  2)
		 call      LEFT_TWO
						 
                 mvi       TEMP2,2               ; 
		 mvi       CHANGE,D'2'           ;  (  2)
		 call      LEFT_TWO

						 ; 5 -   

		 mvi       TIME,DELAY2           ;   
                 mvi       TEMP2,4               ;  
		 mvi       CHANGE,D'253'         ;  (  3)
		 call      RIGHTSPIN
						 
                 mvi       TEMP2,4               ;  
		 clrf      CHANGE                ;  
		 call      RIGHTSPIN
						 
                 mvi       TEMP2,4               ;  
		 mvi       CHANGE,D'3'           ;  (  3)
		 call      RIGHTSPIN

						 ; 6 -   4-2-4

		 mvi       TIME,DELAY4           ;   
                 mvi       TEMP2,2               ; 
		 mvi       CHANGE,D'254'         ;  (  2)
		 call      TWOFOUR
						 
                 mvi       TEMP2,2               ; 
		 mvi       CHANGE,D'2'           ;  (  2)
		 call      TWOFOUR

						 ; 7 -   /

                 mvi       TIME,DELAY1           ;   
                 mvi       TEMP2,8               ;    
		 clrf      CHANGE                ;  
		 call      EVEN_ODD

						 ; 8 -   

		 mvi       TIME,DELAY2           ;   
                 mvi       TEMP2,4               ;  
		 mvi       CHANGE,D'253'         ;  (  3)
		 call      LEFTSPIN
						 
                 mvi       TEMP2,4               ;  
		 clrf      CHANGE                ;  
		 call      LEFTSPIN
						 
                 mvi       TEMP2,4               ;  
		 mvi       CHANGE,D'3'           ;  (  3)
		 call      LEFTSPIN

						 ; 9 -     

		 mvi       TIME,DELAY4           ;   
                 mvi       TEMP2,2               ; 
		 mvi       CHANGE,D'254'         ;  (  2)
		 call      RIGHT_TWO
						 
                 mvi       TEMP2,2               ; 
		 mvi       CHANGE,D'2'           ;  (  2)
		 call      RIGHT_TWO

						 ; 10 -    

		 mvi       TIME,DELAY3           ;   
                 mvi       TEMP2,1               ;  
		 mvi       CHANGE,D'252'         ;  (  4)
		 call      LEFT_ONE
						 
                 mvi       TEMP2,1               ;  
		 mvi       CHANGE,D'4'           ;  (  4)
		 call      LEFT_ONE

						 ; 11 - "" 

		 mvi       TIME,DELAY5           ;   
                 mvi       TEMP2,5               ;  
		 mvi       CHANGE,D'255'         ;  (  1)
		 call      RIGHT_SNAKE
						 
                 mvi       TEMP2,5               ;  
		 mvi       CHANGE,D'1'           ;  (  1)
		 call      RIGHT_SNAKE


		 decf      LONGTIMER,F      ;  - 
                 goto      Mainloop_label   ;    

;--------------------------------------------------------------------------------------------------
                ;
;--------------------------------------------------------------------------------------------------
Melody0		 mvi       SPEED,D'140'     ; 
                			    ; 
		 mvi       TEMP4,02h
Repeat1		 play      B'01111100'
		 play      B'01101010'
		 play      B'01011010'
		 play      B'01101100'
		 play      B'01011010'
		 play      B'01101010'
		 play      B'01111100'
		 play      B'10010010'
		 play      B'01111010'
		 play      B'01101100'
		 decf      TEMP4,W
		 jz        Repeat0
		 play      B'11111100'
		 decfsz    TEMP4,F
		 goto      Repeat1
Repeat0		 play      B'01101010'
		 play      B'01111010'
		 play      B'10000100'
		 play      B'01111010'
		 play      B'01101010'
		 play      B'01011100'
		 play      B'01011010'
		 play      B'01010010'
		 play      B'01011100'
		 play      B'10100100'
		 play      B'10010100'
		 play      B'11111010'
		 mvi       TEMP4,02h
Repeat2		 play      B'01111010'
		 play      B'01101010'
		 play      B'01010010'
		 play      B'01011010'
		 decfsz    TEMP4,F
		 goto      Repeat2
		 play      B'01111010'
		 play      B'01101100'
		 play      B'01101010'
		 play      B'01101010'
		 play      B'00110100'
		 goto      Finish
;--------------------------------------------------------------------------------------------------
Melody1          mvi       SPEED,D'140'	    ; 
                			    ;
		 play      B'01001010'
		 play      B'01100001'
		 play      B'10000010'
		 play      B'10001010'
		 play      B'10000010'
		 play      B'01100010'
		 play      B'01001010'
		 play      B'11111001'
		 play      B'10000001'
		 play      B'10000001'
		 play      B'11111001'
		 play      B'10000001'
		 play      B'01110010'
		 play      B'01100010'
		 play      B'01110010'
		 play      B'01011010'
		 play      B'00111010'
		 play      B'11111010'
		 play      B'00111010'
		 play      B'01011001'
		 play      B'01110010'
		 play      B'10000010'
		 play      B'01110010'
		 play      B'01011010'
		 play      B'00111010'
		 play      B'01110001'
		 play      B'01110001'
		 play      B'11111001'
		 play      B'01110001'
		 play      B'01100010'
		 play      B'01011010'
		 play      B'01001100'
		 goto      Finish
;--------------------------------------------------------------------------------------------------
Melody2		 mvi       SPEED,D'180'     ; 
					    ; 
		 mvi       TEMP4,02h
Repeat3		 play      B'00011010'
		 play      B'00110010'
		 play      B'01011010'
		 play      B'01111100'
		 play      B'01111100'
		 play      B'01011010'
		 play      B'01101100'
		 play      B'10000100'
		 play      B'01111100'
		 play      B'01011100'
		 play      B'00001010'      ;-)
		 play      B'00011010'
		 play      B'00110010'
		 play      B'01011100'
		 play      B'01011100'
		 play      B'00001010'
		 play      B'01010100'
		 play      B'01101100'
		 decf      TEMP4,W
		 jz        Repeat4
		 play      B'01011100'
		 play      B'11111100'
		 decfsz    TEMP4,F
		 goto      Repeat3
Repeat4		 play      B'01011001'
		 play      B'00011001'
		 play      B'01011001'
		 play      B'00011001'
		 play      B'01011001'
		 play      B'00011001'
		 play      B'01011010'
		 goto      Finish
;--------------------------------------------------------------------------------------------------
Melody3		 mvi       SPEED,D'130'     ; 
					    ;
		 play      B'01011010'
		 play      B'01011100'
		 play      B'01010001'
		 play      B'01011001'
		 play      B'01100010'
		 play      B'01011100'
		 play      B'11111010'
		 play      B'01001010'
		 play      B'00111100'
		 play      B'00110001'
		 play      B'00111001'
		 play      B'00110010'
		 play      B'00100100'
		 play      B'11111010'
		 play      B'10000010'
		 play      B'10000100'
		 play      B'01111001'
		 play      B'10000001'
		 play      B'10010010'
		 play      B'10000100'
		 play      B'01111001'
		 play      B'10000001'
		 play      B'10010100'
		 play      B'11111100'
		 play      B'11111100'
		 play      B'10011010'
		 play      B'10010010'
		 play      B'10000010'
		 play      B'01111001'
		 play      B'10010010'
		 play      B'10000010'
		 play      B'11111100'
		 play      B'10000010'
		 play      B'01110010'
		 play      B'01100010'
		 play      B'01011010'
		 play      B'01110010'
		 play      B'01100100'
		 play      B'11111010'
		 play      B'01011010'
		 play      B'01011010'
		 play      B'01110010'
		 play      B'01100010'
		 play      B'01011010'
		 play      B'01001100'
		 play      B'00110001'
		 play      B'00111001'
		 play      B'00100100'
		 goto      Finish
;--------------------------------------------------------------------------------------------------
Melody4		 mvi       SPEED,D'140'     ; 
					    ; 
		 play      B'00101100'
		 play      B'01101100'
		 play      B'01100100'
		 play      B'01010100'
		 play      B'01001100'
		 play      B'01010100'
		 play      B'11111100'
		 play      B'11111100'
		 play      B'00101100'
		 play      B'10001100'
		 play      B'01111100'
		 play      B'01101100'
		 play      B'01100100'
		 play      B'01101100'
		 play      B'11111100'
		 play      B'11111100'
		 play      B'01010100'
		 play      B'10010100'
		 play      B'11111010'
		 play      B'10001010'
		 play      B'01111100'
		 play      B'11111010'
		 play      B'01101010'
		 play      B'01100010'
		 play      B'01101010'
		 play      B'01111100'
		 play      B'11111100'
		 play      B'10010100'
		 play      B'10001100'
		 play      B'01111100'
		 play      B'01101100'
		 play      B'01111100'
		 play      B'01100100'
		 goto      Finish
;--------------------------------------------------------------------------------------------------
Melody5		 mvi       SPEED,D'140'     ; 
					    ;   
		 play      B'00001010'
		 play      B'00001010'
		 play      B'01010100'
		 play      B'01010010'
		 play      B'01000010'
		 play      B'00110010'
		 play      B'00110010'
		 play      B'00101010'
		 play      B'00110010'
		 play      B'01000100'
		 play      B'00011100'
		 play      B'11111100'
		 play      B'00011010'
		 play      B'00011010'
		 play      B'01000100'
		 play      B'01000010'
		 play      B'00110010'
		 play      B'00101010'
		 play      B'00001010'
		 play      B'00011010'
		 play      B'00001010'
		 play      B'01010110'
		 play      B'11111100'
		 play      B'01010010'
		 play      B'01011010'
		 play      B'01101010'
		 play      B'01011010'
		 play      B'01010010'
		 play      B'01000010'
		 play      B'00111010'
		 play      B'00011010'
		 play      B'01011010'
		 play      B'01010010'
		 play      B'01000100'
		 play      B'00011100'
		 play      B'11111100'
		 play      B'10010010'
		 play      B'10001010'
		 play      B'10110010'
		 play      B'10110010'
		 play      B'10110010'
		 play      B'00110010'
		 play      B'01000010'
		 play      B'01000010'
		 play      B'00110010'
		 play      B'00101010'
		 play      B'00011110'
		 goto      Finish
;--------------------------------------------------------------------------------------------------
Melody6		 mvi       SPEED,D'135'     ; 
					    ;  ...
		 play      B'00100010'
		 play      B'01001010'
		 play      B'01100010'
		 play      B'10000010'
		 play      B'10000010'
		 play      B'01110010'
		 play      B'01100010'
		 play      B'10000010'
		 play      B'01110100'
		 play      B'11111100'
		 play      B'00100010'
		 play      B'01000010'
		 play      B'01011010'
		 play      B'01110010'
		 play      B'01110010'
		 play      B'01100010'
		 play      B'01011010'
		 play      B'10000100'
		 play      B'11111100'
		 play      B'10000010'
		 play      B'01111010'
		 play      B'10000010'
		 play      B'10001010'
		 play      B'10000010'
		 play      B'01100010'
		 play      B'01001010'
		 play      B'10011010'
		 play      B'10001100'
		 play      B'11111100'
		 play      B'01011010'
		 play      B'10011010'
		 play      B'10001010'
		 play      B'10000010'
		 play      B'01011010'
		 play      B'01110010'
		 play      B'01100010'
		 play      B'01001100'
		 goto      Finish
;--------------------------------------------------------------------------------------------------
Melody7		 mvi       SPEED,D'130'     ; 
					    ;- ( /)
		 play      B'10001100'
		 play      B'01110100'
		 play      B'11111010'
		 play      B'01001100'
		 play      B'11111010'
		 play      B'10001010'
		 play      B'01110100'
		 play      B'01001010'
		 play      B'10001100'
		 play      B'01110100'
		 play      B'11111010'
		 play      B'01001100'
		 play      B'11111010'
		 play      B'10001010'
		 play      B'10000100'
		 play      B'01110010'
		 play      B'10001100'
		 play      B'10000100'
		 play      B'11111010'
		 play      B'01000100'
		 play      B'11111110'
		 play      B'10001100'
		 play      B'10000100'
		 play      B'11111010'
		 play      B'00111100'
		 play      B'11111010'
		 play      B'10001010'
		 play      B'10000100'
		 play      B'00111010'
		 play      B'10001100'
		 play      B'10000100'
		 play      B'11111010'
		 play      B'00111100'
		 play      B'11111010'
		 play      B'10001010'
		 play      B'10000100'
		 play      B'10001010'
		 play      B'01110100'
		 goto      Finish
;--------------------------------------------------------------------------------------------------
Melody8		 mvi       SPEED,D'140'     ; 
					    ;   / " "
		 mvi       TEMP4,01h
Repeat5		 play      B'01001100'
		 play      B'01110100'
		 play      B'10001100'
		 play      B'10000100'
		 play      B'01110100'
		 play      B'10001100'
		 play      B'01110100'
		 play      B'10000100'
		 play      B'01110101'

		 decfsz    TEMP4,F
		 goto      Repeat6

		 play      B'01010011'
		 play      B'01100011'
		 play      B'01001110'
		 play      B'11111100'
		 goto      Repeat5

Repeat6		 play      B'01001011'
		 play      B'01000011'
		 play      B'00111110'

		 goto      Finish
;--------------------------------------------------------------------------------------------------
Melody9		 mvi       SPEED,D'110'     ; 
					    ;  ( -     EEPROM)
		 
		 bsf       STATUS,RP0       ;  EEPROM    1 (PIC16F628)
		 clrf      EEADR            ;    - 

EE1_label	 bsf       STATUS,RP0       ; 1
		 bsf       EECON1,RD        ;    EEPROM
		 nop                        ;   
		 movf      EEDATA,W         ;    W

		 bcf       STATUS,RP0       ; 0
		 call      Sound            ;
		 bsf       STATUS,RP0       ; 1
		 incf      EEADR,F          ; 
		 movf      EEADR,W
		 bcf       STATUS,RP0       ; 0
		 xorlw     D'58'            ;58     
		 jz        Finish           ;    - 

		 goto      EE1_label
;--------------------------------------------------------------------------------------------------
Melody10	 mvi       SPEED,D'140'     ; 
					    ; ( -     EEPROM)
		 
		 bsf       STATUS,RP0       ;  EEPROM    1 (PIC16F628)
		 mvi       EEADR,D'58'      ;    - c 58- 

EE2_label	 bsf       STATUS,RP0       ; 1
		 bsf       EECON1,RD        ;    EEPROM
		 nop                        ;   
		 movf      EEDATA,W         ;    W

		 bcf       STATUS,RP0       ; 0
		 call      Sound            ;
		 bsf       STATUS,RP0       ; 1
		 incf      EEADR,F          ; 
		 movf      EEADR,W
		 bcf       STATUS,RP0       ; 0
		 xorlw     D'107'           ;49     
		 jz        Finish           ;    - 

		 goto      EE2_label
;--------------------------------------------------------------------------------------------------
Melody11	 mvi       SPEED,D'140'     ; 
					    ;  ( -     EEPROM)
		 
		 bsf       STATUS,RP0       ;  EEPROM    1 (PIC16F628)
		 mvi       EEADR,D'107'     ;    -  107- 

EE3_label	 bsf       STATUS,RP0       ; 1
		 bsf       EECON1,RD        ;    EEPROM
		 nop                        ;   
		 movf      EEDATA,W         ;    W

		 bcf       STATUS,RP0       ; 0
		 call      Sound            ;
		 bsf       STATUS,RP0       ; 1
		 incf      EEADR,F          ; 
		 movf      EEADR,W
		 bcf       STATUS,RP0       ; 0
		 xorlw     D'128'           ;21     
		 jz        Finish           ;    - 

		 goto      EE3_label
;--------------------------------------------------------------------------------------------------

		 ORG       0x2100           ;  EEPROM

		 data      B'00101010'      ; ,  ... (58 )
		 data      B'00000010'
		 data      B'11111010'
		 data      B'00101001'
		 data      B'01000001'
		 data      B'01101001'
		 data      B'01100001'
		 data      B'01100010'
		 data      B'11111100'
		 data      B'00111010'
		 data      B'00000010'
		 data      B'01000011'
		 data      B'00111001'
		 data      B'00101010'
		 data      B'00000010'
		 data      B'11111100'
		 data      B'01000010'
		 data      B'00011010'
		 data      B'01000010'
		 data      B'01100010'
		 data      B'10001011'
		 data      B'01111001'
		 data      B'01111010'
		 data      B'11111010'
		 data      B'00011010'
		 data      B'00011010'
		 data      B'01111011'
		 data      B'01101001'
		 data      B'01101010'
		 data      B'01100010'
		 data      B'11111100'
		 data      B'10001010'
		 data      B'10001010'
		 data      B'10001010'
		 data      B'10001010'
		 data      B'10001011'
		 data      B'11111001'
		 data      B'10001011'
		 data      B'11111001'
		 data      B'10001010'
		 data      B'10001010'
		 data      B'01111010'
		 data      B'01101010'
		 data      B'01100011'
		 data      B'11111001'
		 data      B'11111101'
		 data      B'00101001'
		 data      B'00101001'
		 data      B'01111010'
		 data      B'01101010'
		 data      B'01101010'
		 data      B'01100010'
		 data      B'11111101'
		 data      B'00000001'
		 data      B'00000001'
		 data      B'01100010'
		 data      B'00000010'
		 data      B'00101011'
;--------------------------------------------------------------------------------------------------
		 data      B'00000010'      ; ( /) - 49 
		 data      B'01000010'
		 data      B'00100010'
		 data      B'00111010'
		 data      B'00101100'
		 data      B'11111100'
		 data      B'00000010'
		 data      B'00101010'
		 data      B'00011010'
		 data      B'00011010'
		 data      B'00001100'
		 data      B'11111100'
		 data      B'00000010'
		 data      B'00111010'
		 data      B'00101010'
		 data      B'00101010'
		 data      B'00100100'
		 data      B'11111100'
		 data      B'00000010'
		 data      B'01000010'
		 data      B'00111010'
		 data      B'00111010'
		 data      B'00101100'
		 data      B'11111100'
		 data      B'00101010'
		 data      B'00111010'
		 data      B'01000010'
		 data      B'01100010'
		 data      B'01010100'
		 data      B'00101010'
		 data      B'01100010'
		 data      B'01010010'
		 data      B'11111010'
		 data      B'00011010'
		 data      B'01010010'
		 data      B'01000100'
		 data      B'00011010'
		 data      B'01010010'
		 data      B'01000010'
		 data      B'11111010'
		 data      B'00001010'
		 data      B'01000010'
		 data      B'00111100'
		 data      B'00110010'
		 data      B'01000010'
		 data      B'00111010'
		 data      B'00100010'
		 data      B'00111010'
		 data      B'00101110'
;--------------------------------------------------------------------------------------------------
		 data      B'10010010'      ;  - 21 
		 data      B'01111010'
		 data      B'01101100'
		 data      B'01010100'
		 data      B'01111010'
		 data      B'01111010'
		 data      B'01101010'
		 data      B'01111010'
		 data      B'01011100'
		 data      B'01000100'
		 data      B'11111100'
		 data      B'00110010'
		 data      B'01000010'
		 data      B'01010100'
		 data      B'11111010'
		 data      B'01010010'
		 data      B'10001010'
		 data      B'10001010'
		 data      B'01111010'
		 data      B'01110010'
		 data      B'01111100'
;--------------------------------------------------------------------------------------------------
                 end
;__________________________________________________________________________________________________

